Subject: Comment on nf_queue NF_STOLEN patch

From: Jim Sansing <[email-masked]>
Date: Tue, 18 Oct 2011 15:08:29 -0400

I have been working on a kernel module that registers with netfilter,
and I noticed that a patch was added to nf_queue that changed the
handling of return code NF_FILTER from 'do nothing' to 'free the skb'. 
I'm not sure which kernel version this went in, but the date of the
patch is Feb, 19, 2010.

Everything I have read about netfilter states that it is up to the
netfilter hook to free the skb if NF_STOLEN is returned.  The
implications of this patch from a hook programming perspective are:

1) If the skb is used after the return from the hook, it must be cloned.
2) The original skb must not be freed.

I suggest that a comment be added to include/linux/netfilter.h that says
explicitly the skb will be freed if NF_STOLEN is returned.

Later . . .   Jim